<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top:10px">
            <Form v-show="searchOpen" :d="formId" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="试验名称:" style="margin-left: 1px">
                <Input v-model="formObj.name" @on-enter="_formSearch" name="name" placeholder="请输入试验名称" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">
            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                      class="contHide"></btn-list>
          </Col>
          <!-- 表格 -->
          <Col span="24">
            <PTVXETable
              ref="pageTable"
              :form-id="formId"
              :table-height="tableHeight"
              :get-page="getPage"
              :icon-msg="iconMsg"
              @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :width="item.width"
                :min-width="200"
                :fixed="item.fixed?item.fixed:undefined"
                sortable
              >
                <template slot-scope="scope">
                  <span v-if="item.dateTime">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):''}}</span>
                  <span v-else-if="item.image">
                     {{scope.row.picUri!==undefined?'是':'否'}}
                  </span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
<!--    导入-->
    <!-- 添加、编辑 -->
    <importModal ref="importModal" @on-result-change="_page"></importModal>
    <imageTemplateImport ref="imageTemplateImport"   @on-result-change="_page"></imageTemplateImport>
    <ItemManageEdit ref="editModal" @on-result-change="_page"></ItemManageEdit>
    <IndexManage ref="indexModal" @on-result-change="_page"></IndexManage>
    <FileManage ref="FileManage"></FileManage>
  </div>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { soilAptitude } from '../../../api'
import importModal from '../../../components/import/DownloadTemplateImport'
import imageTemplateImport from '../../../components/import/ImageTemplateImport'
import ItemManageEdit from './ItemManageEdit'
import IndexManage from './IndexManage'
export default {
  name: 'MeterAptitudeManage',
  components: {
    imageTemplateImport,
    importModal,
    ItemManageEdit,
    IndexManage
  },
  data() {
    return {
      formId: 'meterAptitudeManageFormId',
      pageColumns: [
        { title: '试验名称', key: 'name' },
        { title: '英文名称', key: 'elName', width: 160 },
        { title: '检测科室', key: 'groupName', width: 160 },
        { title: '试验项目英文简写', key: 'shortName' },
        { title: '大类', key: 'mainType' },
        { title: '小类', key: 'smallType' },
        { title: '试验方法', key: 'testMethod' }
      ],
      btn: [
        { type: 'success', id: '', name: '添加' },
        { type: 'error', id: '', name: '删除' },
        { type: '', id: '', name: '导入' }
      ],
      iconMsg: [
        { type: 'md-apps', id: '', name: '指标管理' },
        { type: 'md-create', id: '', name: '编辑' },
        // { type: 'md-add', id: '', name: '附件' },
        { type: 'md-trash', id: '', name: '删除' }
        // { type: 'md-add', id: '', name: '操作日志' }
      ],
      formObj: {
        basis: undefined,
        name: undefined,
        code: undefined
      },
      searchOpen: true,
      selectIds: [],
      getPage: {},
      typeData: []
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg) {
      switch (msg) {
        case '添加':
          this._editModal(false)
          break
        case '删除':
          this._deleteSelected()
          break
        case '导入':
          this._import()
          break
        case '导出':
          this._export()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(true, data.id)
          break
        case '删除':
          this._deleteById(data.id)
          break
        case '指标管理':
          this.$refs.indexModal._open(data)
          break
        case '附件':
          this._upload(data.id)
          break
        case '操作日志':
          this._record(data.id)
          break
      }
    },
    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _lookPic(data) {
      if (data.picUri) {
        window.open(data.picUri)
      } else {
        this.$Message.warning('暂无图片！')
      }
    },
    _uploadPic(id) {
      const action = '/meter/v1/aptitude/upload_?aptitudeId=' + id
      const data = {
        importUrl: action,
        downloadUrl: '',
        title: '上传'
      }
      this.$refs.imageTemplateImport._open(data, '上传图片')
    },

    _page: async function() {
      // this.$refs.pageTable._page('search-form-package', 'FoodJudgeBasis/page')
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await soilAptitude.page(this.formObj)
      if (result) {
        console.log(result)
        this.getPage = result
        this.$refs.pageTable._hideLoading()
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'selectIds':
          this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          console.log(ids)
          this._delete(ids)
        }
      })
    },
    _delete: async function(ids) {
      const result = await soilAptitude.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    },
    _deleteById(id) {
      // 删除一条记录
      this._deleteByIds([id])
    },
    _deleteSelected() {
      // 批量删除
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this._deleteByIds(ids, '确定删除这 ' + ids.length + ' 条记录？')
      }
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        this._getById(id)
        // 编辑
        // this.$store.dispatch('FoodJudgeBasis/getById', id).then(() => {
        //   this.$refs.editModal._open(this.$store.state.FoodJudgeBasis.model)
        // })
      } else {
        // 添加
        this.$refs.editModal._open()
      }
    },

    _getById: async function(id) {
      const result = await soilAptitude.getById(id)
      if (result) {
        this.$refs.editModal._open(result)
      }
    },
    // 导入
    _import() {
      const data = {
        importUrl: '/soil/v1/aptitude_exp/import_aptitude/',
        downloadUrl: '/soil/v1/excel/template/SoilAptExpImport',
        title: '授权资质导入'
      }
      this.$refs.importModal._open(data, '授权资质导入')
    },
    // 导出
    _export() {
      console.log('.this.selectIds', this.selectIds)
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择需要导出的数据')
      } else {
        const content = '确定导出 ' + this.selectIds.length + ' 条记录？'
        this.$Modal.confirm({
          title: '提示',
          content: content,
          onOk: () => {
            // eslint-disable-next-line no-undef
            http.open(
              '/food/v1/food_aptitude_judge_basis/food_aptitude_judge_export?ids=' +
                this.selectIds
            )
          }
        })
      }
    }
  }
}
</script>

<style scoped>
</style>
